"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useReCaptcha = void 0;
const react_1 = require("react");
const ReCaptchaProvider_1 = require("./ReCaptchaProvider");
/** React Hook to generate ReCaptcha token
 * @example
 * const { executeRecaptcha } = useReCaptcha()
 */
const useReCaptcha = (passedReCaptchaKey) => {
    const _a = (0, ReCaptchaProvider_1.useReCaptchaContext)(), { grecaptcha, reCaptchaKey } = _a, contextProps = __rest(_a, ["grecaptcha", "reCaptchaKey"]);
    const siteKey = passedReCaptchaKey || reCaptchaKey;
    const executeRecaptcha = (0, react_1.useCallback)((action) => __awaiter(void 0, void 0, void 0, function* () {
        if (typeof (grecaptcha === null || grecaptcha === void 0 ? void 0 : grecaptcha.execute) !== "function") {
            throw new Error("Recaptcha has not been loaded");
        }
        const result = yield grecaptcha.execute(siteKey, { action });
        return result;
    }), [grecaptcha, siteKey]);
    return Object.assign(Object.assign({}, contextProps), { grecaptcha, reCaptchaKey: siteKey, executeRecaptcha });
};
exports.useReCaptcha = useReCaptcha;
//# sourceMappingURL=useReCaptcha.js.map